diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-ru.h ns-3.34/src/wifi/model/he/he-ru.h
--- ns-3.33/src/wifi/model/he/he-ru.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-ru.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,277 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef HE_RU_H
+#define HE_RU_H
+
+#include <map>
+#include <vector>
+#include <cstdint>
+#include <ostream>
+
+namespace ns3 {
+
+
+/**
+ * This class stores the subcarrier groups of all the available HE RUs.
+ */
+class HeRu
+{
+public:
+  /**
+   * The different HE Resource Unit (RU) types.
+   */
+  enum RuType
+  {
+    RU_26_TONE = 0,
+    RU_52_TONE,
+    RU_106_TONE,
+    RU_242_TONE,
+    RU_484_TONE,
+    RU_996_TONE,
+    RU_2x996_TONE
+  };
+
+  /// (lowest index, highest index) pair defining a subcarrier range
+  typedef std::pair<int16_t, int16_t> SubcarrierRange;
+
+  /// a vector of subcarrier ranges defining a subcarrier group
+  typedef std::vector<SubcarrierRange> SubcarrierGroup;
+
+
+  /**
+   * RU Specification. Stores the information carried by the RU Allocation subfield
+   * of the User Info field of Trigger frames (see 9.3.1.22.1 of 802.11ax D8.0).
+   * Note that primary80MHz must be true if ruType is RU_2x996_TONE.
+   * Internally, this class also stores the RU PHY index (ranging from 1 to the number
+   * of RUs of the given type in a channel of the considered width), so that this class
+   * contains all the information needed to locate the RU in a 160 MHz channel.
+   */
+  class RuSpec
+  {
+  public:
+    /**
+     * Default constructor
+     */
+    RuSpec ();
+    /**
+     * Constructor
+     *
+     * \param ruType the RU type
+     * \param index the RU index (starting at 1)
+     * \param primary80MHz whether the RU is allocated in the primary 80MHz channel
+     */
+    RuSpec (RuType ruType, std::size_t index, bool primary80MHz);
+
+    /**
+     * Get the RU type
+     *
+     * \return the RU type
+     */
+    RuType GetRuType (void) const;
+    /**
+     * Get the RU index
+     *
+     * \return the RU index
+     */
+    std::size_t GetIndex (void) const;
+    /**
+     * Get the primary 80 MHz flag
+     *
+     * \return true if the RU is in the primary 80 MHz channel and false otherwise
+     */
+    bool GetPrimary80MHz (void) const;
+    /**
+     * Set the RU PHY index
+     *
+     * \param bw the width of the channel of which the RU is part (in MHz)
+     * \param p20Index the index of the primary20 channel
+     */
+    void SetPhyIndex (uint16_t bw, uint8_t p20Index);
+    /**
+     * Return true if the RU PHY index has been set, false otherwise
+     *
+     * \return true if the RU PHY index has been set, false otherwise
+     */
+    bool IsPhyIndexSet (void) const;
+    /**
+     * Get the RU PHY index
+     *
+     * \return the RU PHY index
+     */
+    std::size_t GetPhyIndex (void) const;
+
+  private:
+    RuType m_ruType;         //!< RU type
+    std::size_t m_index;     /**< RU index (starting at 1) as defined by Tables 27-7
+                                  to 27-9 of 802.11ax D8.0 */
+    bool m_primary80MHz;     //!< true if the RU is allocated in the primary 80MHz channel
+    std::size_t m_phyIndex;  /**< the RU PHY index, which is used to indicate whether an
+                                  RU is located in the lower half or the higher half of
+                                  a 160MHz channel. For channel widths less than 160MHz,
+                                  the RU PHY index equals the RU index */
+  };
+
+
+  /**
+   * Get the number of distinct RUs of the given type (number of tones)
+   * available in a HE PPDU of the given bandwidth.
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ruType the RU type (number of tones)
+   * \return the number of distinct RUs available
+   */
+  static std::size_t GetNRus (uint16_t bw, RuType ruType);
+
+  /**
+   * Get the set of distinct RUs of the given type (number of tones)
+   * available in a HE PPDU of the given bandwidth.
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ruType the RU type (number of tones)
+   * \return the set of distinct RUs available
+   */
+  static std::vector<HeRu::RuSpec> GetRusOfType (uint16_t bw, HeRu::RuType ruType);
+
+  /**
+   * Get the set of 26-tone RUs that can be additionally allocated if the given
+   * bandwidth is split in RUs of the given type.
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ruType the RU type (number of tones)
+   * \return the set of 26-tone RUs that can be additionally allocated
+   */
+  static std::vector<HeRu::RuSpec> GetCentral26TonesRus (uint16_t bw, HeRu::RuType ruType);
+
+  /**
+   * Get the subcarrier group of the RU having the given PHY index among all the
+   * RUs of the given type (number of tones) available in a HE PPDU of the
+   * given bandwidth. A subcarrier group is defined as one or more pairs
+   * indicating the lowest frequency index and the highest frequency index.
+   * Note that for channel width of 160 MHz the returned range is relative to
+   * the 160 MHz channel (i.e. -1012 to 1012). The PHY index parameter is used to
+   * distinguish between lower and higher 80 MHz subchannels.
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ruType the RU type (number of tones)
+   * \param phyIndex the PHY index (starting at 1) of the RU
+   * \return the subcarrier range of the specified RU
+   */
+  static SubcarrierGroup GetSubcarrierGroup (uint16_t bw, RuType ruType, std::size_t phyIndex);
+
+  /**
+   * Check whether the given RU overlaps with the given set of RUs.
+   * Note that for channel width of 160 MHz the returned range is relative to
+   * the 160 MHz channel (i.e. -1012 to 1012).
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ru the given RU allocation
+   * \param v the given set of RUs
+   * \return true if the given RU overlaps with the given set of RUs.
+   */
+  static bool DoesOverlap (uint16_t bw, RuSpec ru, const std::vector<RuSpec> &v);
+
+  /**
+   * Check whether the given RU overlaps with the given tone ranges.
+   * Note that for channel width of 160 MHz the returned range is relative to
+   * the 160 MHz channel (i.e. -1012 to 1012).
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param ru the given RU allocation
+   * \param toneRanges the given set of tone ranges
+   * \return true if the given RU overlaps with the given set of tone ranges.
+   */
+  static bool DoesOverlap (uint16_t bw, RuSpec ru, const SubcarrierGroup &toneRanges);
+
+  /**
+   * Find the RU allocation of the given RU type overlapping the given
+   * reference RU allocation.
+   * Note that an assert is generated if the RU allocation is not found.
+   *
+   * \param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+   * \param referenceRu the reference RU allocation
+   * \param searchedRuType the searched RU type
+   * \return the searched RU allocation.
+   */
+  static RuSpec FindOverlappingRu (uint16_t bw, RuSpec referenceRu, RuType searchedRuType);
+
+  /**
+   * Get the approximate bandwidth occupied by a RU.
+   *
+   * \param ruType the RU type
+   * \return the approximate bandwidth (in MHz) occupied by the RU
+   */
+  static uint16_t GetBandwidth (RuType ruType);
+
+  /**
+   * Get the RU corresponding to the approximate bandwidth.
+   *
+   * \param bandwidth the approximate bandwidth (in MHz) occupied by the RU
+   * \return the RU type
+   */
+  static RuType GetRuType (uint16_t bandwidth);
+
+  /**
+   * Given the channel bandwidth and the number of stations candidate for being
+   * assigned an RU, maximize the number of candidate stations that can be assigned
+   * an RU subject to the constraint that all the stations must be assigned an RU
+   * of the same size (in terms of number of tones).
+   *
+   * \param bandwidth the channel bandwidth in MHz
+   * \param nStations the number of candidate stations. On return, it is set to
+   *                  the number of stations that are assigned an RU
+   * \param[out] nCentral26TonesRus the number of additional 26-tone RUs that can be
+   *                                allocated if the returned RU size is greater than 26 tones
+   * \return the RU type
+   */
+  static RuType GetEqualSizedRusForStations (uint16_t bandwidth, std::size_t& nStations,
+                                             std::size_t& nCentral26TonesRus);
+
+  /// (bandwidth, number of tones) pair
+  typedef std::pair<uint8_t, RuType> BwTonesPair;
+
+  /// map (bandwidth, number of tones) pairs to the group of subcarrier ranges
+  typedef std::map<BwTonesPair, std::vector<SubcarrierGroup> > SubcarrierGroups;
+
+  /// Subcarrier groups for all RUs (with indices being applicable to primary 80 MHz channel)
+  static const SubcarrierGroups  m_heRuSubcarrierGroups;
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param ruType the RU type
+ * \returns a reference to the stream
+ */
+std::ostream& operator<< (std::ostream& os, const HeRu::RuType &ruType);
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param ru the RU
+ * \returns a reference to the stream
+ */
+std::ostream& operator<< (std::ostream& os, const HeRu::RuSpec &ru);
+
+} //namespace ns3
+
+#endif /* HE_RU_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/multi-user-scheduler.cc ns-3.34/src/wifi/model/he/multi-user-scheduler.cc
--- ns-3.33/src/wifi/model/he/multi-user-scheduler.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/multi-user-scheduler.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,185 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "ns3/abort.h"
+#include "multi-user-scheduler.h"
+#include "ns3/qos-txop.h"
+#include "he-configuration.h"
+#include "he-frame-exchange-manager.h"
+#include "ns3/wifi-protection.h"
+#include "ns3/wifi-acknowledgment.h"
+#include "ns3/wifi-mac-trailer.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("MultiUserScheduler");
+
+NS_OBJECT_ENSURE_REGISTERED (MultiUserScheduler);
+
+TypeId
+MultiUserScheduler::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::MultiUserScheduler")
+    .SetParent<Object> ()
+    .SetGroupName ("Wifi")
+  ;
+  return tid;
+}
+
+MultiUserScheduler::MultiUserScheduler ()
+{
+}
+
+MultiUserScheduler::~MultiUserScheduler ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+void
+MultiUserScheduler::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_apMac = 0;
+  m_heFem = 0;
+  m_edca = 0;
+  m_dlInfo.psduMap.clear ();
+  m_dlInfo.txParams.Clear ();
+  m_ulInfo.txParams.Clear ();
+  m_ulInfo.trigger = 0;
+  Object::DoDispose ();
+}
+
+void
+MultiUserScheduler::NotifyNewAggregate ()
+{
+  NS_LOG_FUNCTION (this);
+  if (m_apMac == 0)
+    {
+      Ptr<ApWifiMac> apMac = this->GetObject<ApWifiMac> ();
+      //verify that it's a valid AP mac and that
+      //the AP mac was not set before
+      if (apMac != 0)
+        {
+          this->SetWifiMac (apMac);
+        }
+    }
+  Object::NotifyNewAggregate ();
+}
+
+void
+MultiUserScheduler::DoInitialize (void)
+{
+  // compute the size in bytes of 8 QoS Null frames. It can be used by subclasses
+  // when responding to a BSRP Trigger Frame
+  WifiMacHeader header;
+  header.SetType (WIFI_MAC_QOSDATA_NULL);
+  header.SetDsTo ();
+  header.SetDsNotFrom ();
+  uint32_t headerSize = header.GetSerializedSize ();
+
+  m_sizeOf8QosNull = 0;
+  for (uint8_t i = 0; i < 8; i++)
+    {
+      m_sizeOf8QosNull = MpduAggregator::GetSizeIfAggregated (headerSize + WIFI_MAC_FCS_LENGTH, m_sizeOf8QosNull);
+    }
+}
+
+void
+MultiUserScheduler::SetWifiMac (Ptr<ApWifiMac> mac)
+{
+  NS_LOG_FUNCTION (this << mac);
+  m_apMac = mac;
+
+  // When VHT DL MU-MIMO will be supported, we will have to lower this requirement
+  // and allow a Multi-user scheduler to be installed on a VHT AP.
+  NS_ABORT_MSG_IF (m_apMac == 0 || m_apMac->GetHeConfiguration () == 0,
+                   "MultiUserScheduler can only be installed on HE APs");
+
+  m_heFem = DynamicCast<HeFrameExchangeManager> (m_apMac->GetFrameExchangeManager ());
+  m_heFem->SetMultiUserScheduler (this);
+}
+
+Ptr<WifiRemoteStationManager>
+MultiUserScheduler::GetWifiRemoteStationManager (void) const
+{
+  return m_apMac->GetWifiRemoteStationManager ();
+}
+
+MultiUserScheduler::TxFormat
+MultiUserScheduler::NotifyAccessGranted (Ptr<QosTxop> edca, Time availableTime, bool initialFrame)
+{
+  NS_LOG_FUNCTION (this << edca << availableTime << initialFrame);
+
+  m_edca = edca;
+  m_availableTime = availableTime;
+  m_initialFrame = initialFrame;
+
+  TxFormat txFormat = SelectTxFormat ();
+
+  if (txFormat == DL_MU_TX)
+    {
+      m_dlInfo = ComputeDlMuInfo ();
+    }
+  else if (txFormat == UL_MU_TX)
+    {
+      NS_ABORT_MSG_IF (m_heFem == 0, "UL MU PPDUs are only supported by HE APs");
+      m_ulInfo = ComputeUlMuInfo ();
+    }
+
+  if (txFormat != NO_TX)
+    {
+      m_lastTxFormat = txFormat;
+    }
+  return txFormat;
+}
+
+MultiUserScheduler::TxFormat
+MultiUserScheduler::GetLastTxFormat (void) const
+{
+  return m_lastTxFormat;
+}
+
+MultiUserScheduler::DlMuInfo&
+MultiUserScheduler::GetDlMuInfo (void)
+{
+  NS_ABORT_MSG_IF (m_lastTxFormat != DL_MU_TX, "Next transmission is not DL MU");
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+  // check that all the addressed stations support HE
+  for (auto& psdu : m_dlInfo.psduMap)
+    {
+      NS_ABORT_MSG_IF (!GetWifiRemoteStationManager ()->GetHeSupported (psdu.second->GetAddr1 ()),
+                       "Station " << psdu.second->GetAddr1 () << " does not support HE");
+    }
+#endif
+
+  return m_dlInfo;
+}
+
+MultiUserScheduler::UlMuInfo&
+MultiUserScheduler::GetUlMuInfo (void)
+{
+  NS_ABORT_MSG_IF (m_lastTxFormat != UL_MU_TX, "Next transmission is not UL MU");
+
+  return m_ulInfo;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/multi-user-scheduler.h ns-3.34/src/wifi/model/he/multi-user-scheduler.h
--- ns-3.33/src/wifi/model/he/multi-user-scheduler.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/multi-user-scheduler.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,178 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef MULTI_USER_SCHEDULER_H
+#define MULTI_USER_SCHEDULER_H
+
+#include "ns3/object.h"
+#include "he-ru.h"
+#include "ns3/ctrl-headers.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/wifi-mac-queue.h"
+#include "ns3/wifi-tx-parameters.h"
+#include "ns3/wifi-remote-station-manager.h"
+#include <unordered_map>
+
+namespace ns3 {
+
+class HeFrameExchangeManager;
+
+typedef std::unordered_map <uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
+
+/**
+ * \ingroup wifi
+ *
+ * MultiUserScheduler is an abstract base class defining the API that APs
+ * supporting at least VHT can use to determine the format of their next transmission.
+ * VHT APs can only transmit DL MU PPDUs by using MU-MIMO, while HE APs can
+ * transmit both DL MU PPDUs and UL MU PPDUs by using OFDMA in addition to MU-MIMO.
+ *
+ * However, given that DL MU-MIMO is not yet supported, a MultiUserScheduler can
+ * only be aggregated to HE APs.
+ */
+class MultiUserScheduler : public Object
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  MultiUserScheduler ();
+  virtual ~MultiUserScheduler ();
+
+  /// Enumeration of the possible transmission formats
+  enum TxFormat
+  {
+    NO_TX = 0,
+    SU_TX,
+    DL_MU_TX,
+    UL_MU_TX
+  };
+
+  /// Information to be provided in case of DL MU transmission
+  struct DlMuInfo
+  {
+    WifiPsduMap psduMap;            //!< the DL MU PPDU to transmit
+    WifiTxParameters txParams;      //!< the transmission parameters
+  };
+
+  /// Information to be provided in case of UL MU transmission
+  struct UlMuInfo
+  {
+    Ptr<WifiMacQueueItem> trigger;  //!< the Trigger frame used to solicit TB PPDUs
+    Time tbPpduDuration;            //!< the duration of the solicited TB PPDU
+    WifiTxParameters txParams;      //!< the transmission parameters for the Trigger Frame
+  };
+
+  /**
+   * Notify the Multi-user Scheduler that the given AC of the AP gained channel
+   * access. The Multi-user Scheduler determines the format of the next transmission.
+   *
+   * \param edca the EDCAF which has been granted the opportunity to transmit
+   * \param availableTime the amount of time allowed for the frame exchange. Pass
+   *                      Time::Min() in case the TXOP limit is null
+   * \param initialFrame true if the frame being transmitted is the initial frame
+   *                     of the TXOP. This is used to determine whether the TXOP
+   *                     limit can be exceeded
+   * \return the format of the next transmission
+   */
+  TxFormat NotifyAccessGranted (Ptr<QosTxop> edca, Time availableTime, bool initialFrame);
+
+  /**
+   * Get the information required to perform a DL MU transmission. Note
+   * that this method can only be called if GetTxFormat returns DL_MU_TX.
+   *
+   * \return the information required to perform a DL MU transmission
+   */
+  DlMuInfo& GetDlMuInfo (void);
+
+  /**
+   * Get the information required to solicit an UL MU transmission. Note
+   * that this method can only be called if GetTxFormat returns UL_MU_TX.
+   *
+   * \return the information required to solicit an UL MU transmission
+   */
+  UlMuInfo& GetUlMuInfo (void);
+
+protected:
+  /**
+   * Get the station manager attached to the AP.
+   *
+   * \return the station manager attached to the AP
+   */
+  Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const;
+
+  /**
+   * Get the format of the last transmission, as determined by the last call
+   * to NotifyAccessGranted that did not return NO_TX.
+   *
+   * \return the format of the last transmission
+   */
+  TxFormat GetLastTxFormat (void) const;
+
+  void DoDispose (void) override;
+  void NotifyNewAggregate (void) override;
+  void DoInitialize (void) override;
+
+  Ptr<ApWifiMac> m_apMac;                //!< the AP wifi MAC
+  Ptr<HeFrameExchangeManager> m_heFem;   //!< HE Frame Exchange Manager
+  Ptr<QosTxop> m_edca;                   //!< the AC that gained channel access
+  Time m_availableTime;                  //!< the time available for frame exchange
+  bool m_initialFrame;                   //!< true if a TXOP is being started
+  uint32_t m_sizeOf8QosNull;             //!< size in bytes of 8 QoS Null frames
+
+private:
+  /**
+   * Set the wifi MAC. Note that it must be the MAC of an HE AP.
+   *
+   * \param mac the AP wifi MAC
+   */
+  void SetWifiMac (Ptr<ApWifiMac> mac);
+
+  /**
+   * Select the format of the next transmission.
+   *
+   * \return the format of the next transmission
+   */
+  virtual TxFormat SelectTxFormat (void) = 0;
+
+  /**
+   * Compute the information required to perform a DL MU transmission.
+   *
+   * \return the information required to perform a DL MU transmission
+   */
+  virtual DlMuInfo ComputeDlMuInfo (void) = 0;
+
+  /**
+   * Prepare the information required to solicit an UL MU transmission.
+   *
+   * \return the information required to solicit an UL MU transmission
+   */
+  virtual UlMuInfo ComputeUlMuInfo (void) = 0;
+
+  TxFormat m_lastTxFormat {NO_TX};       //!< the format of last transmission
+  DlMuInfo m_dlInfo;                     //!< information required to perform a DL MU transmission
+  UlMuInfo m_ulInfo;                     //!< information required to solicit an UL MU transmission
+};
+
+} //namespace ns3
+
+#endif /* MULTI_USER_SCHEDULER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/mu-snr-tag.cc ns-3.34/src/wifi/model/he/mu-snr-tag.cc
--- ns-3.33/src/wifi/model/he/mu-snr-tag.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/mu-snr-tag.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,113 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "mu-snr-tag.h"
+
+namespace ns3 {
+
+NS_OBJECT_ENSURE_REGISTERED (MuSnrTag);
+
+TypeId
+MuSnrTag::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::MuSnrTag")
+    .SetParent<Tag> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<MuSnrTag> ()
+  ;
+  return tid;
+}
+
+TypeId
+MuSnrTag::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+MuSnrTag::MuSnrTag ()
+{
+}
+
+void
+MuSnrTag::Reset (void)
+{
+  m_snrMap.clear ();
+}
+
+void
+MuSnrTag::Set (uint16_t staId, double snr)
+{
+  m_snrMap[staId] = snr;
+}
+
+bool
+MuSnrTag::IsPresent (uint16_t staId) const
+{
+  return (m_snrMap.find (staId) != m_snrMap.end ());
+}
+
+double
+MuSnrTag::Get (uint16_t staId) const
+{
+  NS_ASSERT (IsPresent (staId));
+  return m_snrMap.at (staId);
+}
+
+uint32_t
+MuSnrTag::GetSerializedSize (void) const
+{
+  return (sizeof (uint16_t) + sizeof (double)) * m_snrMap.size () + 1;
+}
+
+void
+MuSnrTag::Serialize (TagBuffer i) const
+{
+  i.WriteU8 (m_snrMap.size ());
+
+  for (const auto& staIdSnrPair : m_snrMap)
+    {
+      i.WriteU16 (staIdSnrPair.first);
+      i.WriteDouble (staIdSnrPair.second);
+    }
+}
+
+void
+MuSnrTag::Deserialize (TagBuffer i)
+{
+  uint8_t n = i.ReadU8 ();
+  for (uint8_t j = 0; j < n; j++)
+    {
+      uint16_t staId = i.ReadU16 ();
+      double snr = i.ReadDouble ();
+      m_snrMap.insert ({staId, snr});
+    }
+}
+
+void
+MuSnrTag::Print (std::ostream &os) const
+{
+  for (const auto& staIdSnrPair : m_snrMap)
+    {
+      os << "{STA-ID=" << staIdSnrPair.first << " Snr=" << staIdSnrPair.second << "} ";
+    }
+  os << std::endl;
+}
+
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/mu-snr-tag.h ns-3.34/src/wifi/model/he/mu-snr-tag.h
--- ns-3.33/src/wifi/model/he/mu-snr-tag.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/mu-snr-tag.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,88 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef MU_SNR_TAG_H
+#define MU_SNR_TAG_H
+
+#include "ns3/tag.h"
+#include <map>
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * A tag to be attached to a response to a multi-user UL frame, that carries the SNR
+ * values with which the individual frames have been received.
+ */
+class MuSnrTag : public Tag
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  TypeId GetInstanceTypeId (void) const override;
+
+  /**
+   * Create an empty MuSnrTag
+   */
+  MuSnrTag ();
+
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (TagBuffer i) const override;
+  void Deserialize (TagBuffer i) override;
+  void Print (std::ostream &os) const override;
+
+  /**
+   * Reset the content of the tag.
+   */
+  void Reset (void);
+  /**
+   * Set the SNR for the given sender to the given value.
+   *
+   * \param staId the STA-ID of the given sender
+   * \param snr the value of the SNR to set in linear scale
+   */
+  void Set (uint16_t staId, double snr);
+  /**
+   * Return true if the SNR value for the given STA-ID is present
+   *
+   * \param staId the STA-ID
+   * \return true if the SNR value for the given STA-ID is present
+   */
+  bool IsPresent (uint16_t staId) const;
+  /**
+   * Return the SNR value for the given sender.
+   *
+   * \param staId the STA-ID of the given sender
+   * \return the SNR value in linear scale
+   */
+  double Get (uint16_t staId) const;
+
+
+private:
+  std::map<uint16_t, double> m_snrMap;     //!< Map containing (STA-ID, SNR) pairs
+};
+
+}
+
+#endif /* MU_SNR_TAG_H */
